#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>

#define PIPE_IN "/tmp/mimdemo-in"
#define PIPE_OUT "/tmp/mimdemo-out"

int
main ()
{
  FILE *in, *out;
  mode_t mode = S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH;
  int c;

  umask (0);
  if (mkfifo (PIPE_IN, mode) < 0 && errno != EEXIST)
    {
      fprintf (stderr, "Failed to make a named pipe.\n");
      exit (1);
    }

  if (mkfifo (PIPE_OUT, mode) < 0 && errno != EEXIST)
    {
      fprintf (stderr, "Failed to make a named pipe.\n");
      exit (1);
    }

  do {
    printf ("accepting...");
    fflush (stdout);
    in = fopen (PIPE_IN, "r");
    printf ("\nconnecting...");
    fflush (stdout);
    out = fopen (PIPE_OUT, "w");
    printf ("done\n");
    if (! in || ! out)
      {
	fprintf (stderr, "Failed to open a named pipe.\n");
	exit (1);
      }
    while ((c = getc (in)) != EOF && c != '!')
      {
	putchar (c);
	putc (toupper (c), out);
	fflush (out);
      }
    fclose (in);
    fclose (out);
  } while (c != '!'); 

  unlink (PIPE_IN);
  unlink (PIPE_OUT);
  exit (0);
}
